# Описание
DITranquallity - это небольшая библиотека для внедрения зависимостей для iOS приложений написанных на Swift. Библиотека поддерживает "Чистые" Swift типы. 

# Оглавление

### [Быстрый старт](quick_start.md)
* Структура приложений
* Добавление DITranquallity в ваш проект
* Регистрация зависимостей
* Разрешение зависимостей
* Что дальше?

### [Базовая регистрации зависимостей](registration.md)
* Регистрация зависимости
* Метод инициализации
* Указание альтернативных типов
* Разрешение зависимостей при инициализации
* Методы для добавления зависимостей
* Циклические ссылки
* Передача параметров

### [Создание контейнера](build.md)
* Зачем?
* Процесс создания
* Проверки во время создания
* Чего нету

### [Время жизни](timelife.md)
* Зачем?
* Стандартное (Default)
* Одиночки (Single)
* Отложенные одиночки (LazySingle)
* Область видимости (Scope)
* Всегда новый (Dependency)
* За создание отвечает кто-то другой (Request)

### [Регистрация с указанием имени/множественная регистрация](multi_name_registration.md)
* Множественная регистрация
* Указание Стандартной (Default) зависимости
* Регистрация с указанием имени

### [Разрешение зависимостей](resolve.md)
* Разрешение по типу
* Разрешение по типу и имени
* Разрешение зависимостей для множественной регистрации
* Разрешение зависимостей с параметрами
* Автоматический вывод типов
* Проверки во время разрешения зависимостей
* Сокращенный синтаксис

### [Модули](module.md)
* Что такое модуль?
* Создание модуля
* Регистрация модуля

### [Сборки](assembly.md)
* Зачем?
* Как использовать
* Динамические сборки
* Нюансы

### Storyboard
* Объявление зависимостей для ViewController
* Создание Storyboard
* Объявление Single ViewController

### "Идеальная" архитектура приложения

### Примеры

